      subroutine kinkk2(ikin,imom,ecm,m,p,x,ndim,dlips)
 
      use inprms
      use kincuts
      use ntnkin
 
      implicit none
 
      integer, parameter :: nepl=8
      integer :: ikin,imom,ndim
      real(dp) :: ecm,m(nepl),p(0:3,nepl),x(ndim),dlips,v(3),g
      real(dp), dimension(0:3) :: q1,q2,q3,q4
      real(dp) :: sqsl1,sqsl2,sqsl3,sqsl4
      real(dp) :: sqsu1,sqsu2,sqsu3,sqsu4
      real(dp) :: sqs1,sqs2,sqs3,sqs4
      real(dp) :: ds1,ds2,ds3,ds4
      real(dp) :: s1,s2,s3,s4
      real(dp) :: dl1,dl2,dl3,dl4
 
      if (ikin <= nt42) then                                                    
       sqsl1=m(7)+m(8)                                                          
       sqsl2=m(3)+m(6)                                                          
       sqsl3=m(5)+sqsl2                                                         
       sqsl4=sqsl3+m(4)                                                         
       if (imom /= 1) then                                                      
        q1=p(:,7)+p(:,8)                                                        
        q2=p(:,3)+p(:,6)                                                        
        q3=p(:,5)+q2                                                            
        q4=q3+p(:,4)                                                            
       end if                                                                   
       if (ikin == 43) then                                                     
       sqsu1=ecm-sqsl4                                                          
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)                
       sqsu4=ecm-sqs1                                                           
       call mapbkk(imom,x(4),q4,mw,gamw,sqsl4,sqsu4,s4,sqs4,ds4)                
       sqsu3=sqs4-m(4)                                                          
       call mapbkk(imom,x(3),q3,zero,zero,sqsl3,sqsu3,s3,sqs3,ds3)              
       sqsu2=sqs3-m(5)                                                          
       call mapbkk(imom,x(2),q2,mz,gamz,sqsl2,sqsu2,s2,sqs2,ds2)                
       end if                                                                   
       call kinff(imom,sqs1,m(7),m(8),x(5:6),p(:,7),p(:,8),dl1)
       call kinff(imom,sqs2,m(3),m(6),x(7:8),p(:,3),p(:,6),dl2)
       call kinff(imom,sqs3,m(5),sqs2,x(9:10),p(:,5),q2,dl3)
       call kinff(imom,sqs4,sqs3,m(4),x(11:12),q3,p(:,4),dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,4))
       end if
      else if (ikin <= nt46) then
       sqsl1=m(7)+m(4)
       sqsl2=m(3)+m(6)
       sqsl3=sqsl2+m(8)
       sqsl4=m(5)+sqsl3
       if (imom /= 1) then
        q1=p(:,7)+p(:,4)
        q2=p(:,3)+p(:,6)
        q3=q2+p(:,8)
        q4=p(:,5)+q3
       end if
       if (ikin == 44) then
       sqsu1=ecm-sqsl4
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,zero,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(8)
       call mapbkk(imom,x(2),q2,mz,gamz,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(7),m(4),x(5:6),p(:,7),p(:,4),dl1)
       call kinff(imom,sqs2,m(3),m(6),x(7:8),p(:,3),p(:,6),dl2)
       call kinff(imom,sqs3,sqs2,m(8),x(9:10),q2,p(:,8),dl3)
       call kinff(imom,sqs4,m(5),sqs3,x(11:12),p(:,5),q3,dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,4))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,8))
       end if
      else if (ikin <= nt47) then
       sqsl1=m(7)+m(4)
       sqsl2=m(3)+m(6)
       sqsl3=m(5)+m(8)
       sqsl4=sqsl2+sqsl3
       if (imom /= 1) then
        q1=p(:,7)+p(:,4)
        q2=p(:,3)+p(:,6)
        q3=p(:,5)+p(:,8)
        q4=q2+q3
       end if
       if (ikin == 45) then
       sqsu1=ecm-sqsl4
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-sqsl2
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs4-sqs3
       call mapbkk(imom,x(2),q2,mh,gamh,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(7),m(4),x(5:6),p(:,7),p(:,4),dl1)
       call kinff(imom,sqs2,m(3),m(6),x(7:8),p(:,3),p(:,6),dl2)
       call kinff(imom,sqs3,m(5),m(8),x(9:10),p(:,5),p(:,8),dl3)
       call kinff(imom,sqs4,sqs2,sqs3,x(11:12),q2,q3,dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,4))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
       end if
      else if (ikin <= nt48) then
       sqsl1=m(7)+m(4)
       sqsl2=m(3)+m(6)
       sqsl3=m(5)+sqsl2
       sqsl4=sqsl3+m(8)
       if (imom /= 1) then
        q1=p(:,7)+p(:,4)
        q2=p(:,3)+p(:,6)
        q3=p(:,5)+q2
        q4=q3+p(:,8)
       end if
       if (ikin == 46) then
       sqsu1=ecm-sqsl4
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(8)
       call mapbkk(imom,x(3),q3,zero,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       call mapbkk(imom,x(2),q2,mz,gamz,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(7),m(4),x(5:6),p(:,7),p(:,4),dl1)
       call kinff(imom,sqs2,m(3),m(6),x(7:8),p(:,3),p(:,6),dl2)
       call kinff(imom,sqs3,m(5),sqs2,x(9:10),p(:,5),q2,dl3)
       call kinff(imom,sqs4,sqs3,m(8),x(11:12),q3,p(:,8),dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,4))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,8))
       end if
      else if (ikin <= nt53) then
       sqsl1=m(3)+m(6)
       sqsl2=m(7)+sqsl1
       sqsl3=m(5)+m(8)
       sqsl4=sqsl2+sqsl3
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,7)+q1
        q3=p(:,5)+p(:,8)
        q4=q2+q3
       end if
       if (ikin == 47) then
       sqsu4=ecm-m(4)
       ds4=(sqsu4-sqsl4)*(sqsu4+sqsl4)
       if (imom == 1) then
        s4=ds4*x(4)+sqsl4*sqsl4
       else
        s4=(q4(0)-q4(3))*(q4(0)+q4(3))-q4(1)*q4(1)-q4(2)*q4(2)
       end if
       sqs4=sqrt(s4)
       sqsu3=sqs4-sqsl2
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs4-sqs3
       call mapbkk(imom,x(2),q2,mmu,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 48) then
       sqsu4=ecm-m(4)
       ds4=(sqsu4-sqsl4)*(sqsu4+sqsl4)
       if (imom == 1) then
        s4=ds4*x(4)+sqsl4*sqsl4
       else
        s4=(q4(0)-q4(3))*(q4(0)+q4(3))-q4(1)*q4(1)-q4(2)*q4(2)
       end if
       sqs4=sqrt(s4)
       sqsu3=sqs4-sqsl2
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs4-sqs3
       call mapbkk(imom,x(2),q2,mmu,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(7),sqs1,x(7:8),p(:,7),q1,dl2)
       call kinff(imom,sqs3,m(5),m(8),x(9:10),p(:,5),p(:,8),dl3)
       call kinff(imom,sqs4,sqs2,sqs3,x(11:12),q2,q3,dl4)
       call kinff(imom,ecm,m(4),sqs4,x(13:14),p(:,4),q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
       end if
      else if (ikin <= nt54) then
       sqsl1=m(3)+m(6)
       sqsl2=m(5)+m(8)
       sqsl3=m(7)+sqsl2
       sqsl4=sqsl3+sqsl1
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,5)+p(:,8)
        q3=p(:,7)+q2
        q4=q3+q1
       end if
       if (ikin == 49) then
       sqsu4=ecm-m(4)
       ds4=(sqsu4-sqsl4)*(sqsu4+sqsl4)
       if (imom == 1) then
        s4=ds4*x(4)+sqsl4*sqsl4
       else
        s4=(q4(0)-q4(3))*(q4(0)+q4(3))-q4(1)*q4(1)-q4(2)*q4(2)
       end if
       sqs4=sqrt(s4)
       sqsu3=sqs4-sqsl1
       call mapbkk(imom,x(3),q3,mmu,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mz,gamz,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs4-sqs3
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 50) then
       sqsu4=ecm-m(4)
       ds4=(sqsu4-sqsl4)*(sqsu4+sqsl4)
       if (imom == 1) then
        s4=ds4*x(4)+sqsl4*sqsl4
       else
        s4=(q4(0)-q4(3))*(q4(0)+q4(3))-q4(1)*q4(1)-q4(2)*q4(2)
       end if
       sqs4=sqrt(s4)
       sqsu3=sqs4-sqsl1
       call mapbkk(imom,x(3),q3,mmu,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mz,gamz,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs4-sqs3
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(5),m(8),x(7:8),p(:,5),p(:,8),dl2)
       call kinff(imom,sqs3,m(7),sqs2,x(9:10),p(:,7),q2,dl3)
       call kinff(imom,sqs4,sqs3,sqs1,x(11:12),q3,q1,dl4)
       call kinff(imom,ecm,m(4),sqs4,x(13:14),p(:,4),q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt55) then
       sqsl1=m(3)+m(6)
       sqsl2=m(7)+m(8)
       sqsl3=m(5)+sqsl2
       sqsl4=sqsl3+sqsl1
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,7)+p(:,8)
        q3=p(:,5)+q2
        q4=q3+q1
       end if
       if (ikin == 51) then
       sqsu4=ecm-m(4)
       ds4=(sqsu4-sqsl4)*(sqsu4+sqsl4)
       if (imom == 1) then
        s4=ds4*x(4)+sqsl4*sqsl4
       else
        s4=(q4(0)-q4(3))*(q4(0)+q4(3))-q4(1)*q4(1)-q4(2)*q4(2)
       end if
       sqs4=sqrt(s4)
       sqsu3=sqs4-sqsl1
       call mapbkk(imom,x(3),q3,mmu,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs4-sqs3
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 52) then
       sqsu4=ecm-m(4)
       ds4=(sqsu4-sqsl4)*(sqsu4+sqsl4)
       if (imom == 1) then
        s4=ds4*x(4)+sqsl4*sqsl4
       else
        s4=(q4(0)-q4(3))*(q4(0)+q4(3))-q4(1)*q4(1)-q4(2)*q4(2)
       end if
       sqs4=sqrt(s4)
       sqsu3=sqs4-sqsl1
       call mapbkk(imom,x(3),q3,mmu,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs4-sqs3
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(7),m(8),x(7:8),p(:,7),p(:,8),dl2)
       call kinff(imom,sqs3,m(5),sqs2,x(9:10),p(:,5),q2,dl3)
       call kinff(imom,sqs4,sqs3,sqs1,x(11:12),q3,q1,dl4)
       call kinff(imom,ecm,m(4),sqs4,x(13:14),p(:,4),q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt59) then
       sqsl1=m(3)+m(6)
       sqsl2=m(5)+sqsl1
       sqsl3=m(7)+m(8)
       sqsl4=sqsl2+sqsl3
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,5)+q1
        q3=p(:,7)+p(:,8)
        q4=q2+q3
       end if
       if (ikin == 53) then
       sqsu4=ecm-m(4)
       ds4=(sqsu4-sqsl4)*(sqsu4+sqsl4)
       if (imom == 1) then
        s4=ds4*x(4)+sqsl4*sqsl4
       else
        s4=(q4(0)-q4(3))*(q4(0)+q4(3))-q4(1)*q4(1)-q4(2)*q4(2)
       end if
       sqs4=sqrt(s4)
       sqsu3=sqs4-sqsl2
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs4-sqs3
       call mapbkk(imom,x(2),q2,zero,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(5)
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(5),sqs1,x(7:8),p(:,5),q1,dl2)
       call kinff(imom,sqs3,m(7),m(8),x(9:10),p(:,7),p(:,8),dl3)
       call kinff(imom,sqs4,sqs2,sqs3,x(11:12),q2,q3,dl4)
       call kinff(imom,ecm,m(4),sqs4,x(13:14),p(:,4),q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
       end if
      else if (ikin <= nt60) then
       sqsl1=m(3)+m(6)
       sqsl2=m(5)+sqsl1
       sqsl3=m(7)+m(4)
       sqsl4=sqsl2+sqsl3
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,5)+q1
        q3=p(:,7)+p(:,4)
        q4=q2+q3
       end if
       if (ikin == 54) then
       sqsu4=ecm-m(8)
       ds4=(sqsu4-sqsl4)*(sqsu4+sqsl4)
       if (imom == 1) then
        s4=ds4*x(4)+sqsl4*sqsl4
       else
        s4=(q4(0)-q4(3))*(q4(0)+q4(3))-q4(1)*q4(1)-q4(2)*q4(2)
       end if
       sqs4=sqrt(s4)
       sqsu3=sqs4-sqsl2
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs4-sqs3
       call mapbkk(imom,x(2),q2,zero,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(5)
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(5),sqs1,x(7:8),p(:,5),q1,dl2)
       call kinff(imom,sqs3,m(7),m(4),x(9:10),p(:,7),p(:,4),dl3)
       call kinff(imom,sqs4,sqs2,sqs3,x(11:12),q2,q3,dl4)
       call kinff(imom,ecm,m(8),sqs4,x(13:14),p(:,8),q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,4))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,4))
       end if
      else if (ikin <= nt61) then
       sqsl1=m(3)+m(6)
       sqsl2=m(5)+m(8)
       sqsl3=sqsl1+sqsl2
       sqsl4=m(7)+m(4)
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,5)+p(:,8)
        q3=q1+q2
        q4=p(:,7)+p(:,4)
       end if
       if (ikin == 55) then
       sqsu4=ecm-sqsl3
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=ecm-sqs4
       call mapbkk(imom,x(3),q3,mh,gamh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapbkk(imom,x(2),q2,mz,gamz,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(5),m(8),x(7:8),p(:,5),p(:,8),dl2)
       call kinff(imom,sqs3,sqs1,sqs2,x(9:10),q1,q2,dl3)
       call kinff(imom,sqs4,m(7),m(4),x(11:12),p(:,7),p(:,4),dl4)
       call kinff(imom,ecm,sqs3,sqs4,x(13:14),q3,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,4))
       end if
      else if (ikin <= nt62) then
       sqsl1=m(3)+m(6)
       sqsl2=m(5)+sqsl1
       sqsl3=m(7)+m(8)
       sqsl4=sqsl3+m(4)
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,5)+q1
        q3=p(:,7)+p(:,8)
        q4=q3+p(:,4)
       end if
       if (ikin == 56) then
       sqsu4=ecm-sqsl2
       call mapbkk(imom,x(4),q4,zero,zero,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(4)
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=ecm-sqs4
       call mapbkk(imom,x(2),q2,zero,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(5)
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(5),sqs1,x(7:8),p(:,5),q1,dl2)
       call kinff(imom,sqs3,m(7),m(8),x(9:10),p(:,7),p(:,8),dl3)
       call kinff(imom,sqs4,sqs3,m(4),x(11:12),q3,p(:,4),dl4)
       call kinff(imom,ecm,sqs2,sqs4,x(13:14),q2,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,4))
       end if
      else if (ikin <= nt63) then
       sqsl1=m(3)+m(6)
       sqsl2=m(5)+sqsl1
       sqsl3=m(7)+m(4)
       sqsl4=sqsl3+m(8)
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,5)+q1
        q3=p(:,7)+p(:,4)
        q4=q3+p(:,8)
       end if
       if (ikin == 57) then
       sqsu4=ecm-sqsl2
       call mapbkk(imom,x(4),q4,zero,zero,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(8)
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=ecm-sqs4
       call mapbkk(imom,x(2),q2,zero,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(5)
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(5),sqs1,x(7:8),p(:,5),q1,dl2)
       call kinff(imom,sqs3,m(7),m(4),x(9:10),p(:,7),p(:,4),dl3)
       call kinff(imom,sqs4,sqs3,m(8),x(11:12),q3,p(:,8),dl4)
       call kinff(imom,ecm,sqs2,sqs4,x(13:14),q2,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,4))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,8))
       end if
      else if (ikin <= nt64) then
       sqsl1=m(7)+m(4)
       sqsl2=m(5)+m(8)
       sqsl3=sqsl2+m(6)
       sqsl4=m(3)+sqsl3
       if (imom /= 1) then
        q1=p(:,7)+p(:,4)
        q2=p(:,5)+p(:,8)
        q3=q2+p(:,6)
        q4=p(:,3)+q3
       end if
       if (ikin == 58) then
       sqsu1=ecm-sqsl4
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(3)
       call mapbkk(imom,x(3),q3,mb0,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapbkk(imom,x(2),q2,mz,gamz,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 59) then
       sqsu1=ecm-sqsl4
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(3)
       call mapbkk(imom,x(3),q3,mb0,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapbkk(imom,x(2),q2,mz,gamz,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(7),m(4),x(5:6),p(:,7),p(:,4),dl1)
       call kinff(imom,sqs2,m(5),m(8),x(7:8),p(:,5),p(:,8),dl2)
       call kinff(imom,sqs3,sqs2,m(6),x(9:10),q2,p(:,6),dl3)
       call kinff(imom,sqs4,m(3),sqs3,x(11:12),p(:,3),q3,dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,4))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,6))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt66) then
       sqsl1=m(5)+m(8)
       sqsl2=sqsl1+m(6)
       sqsl3=m(3)+sqsl2
       sqsl4=m(7)+m(4)
       if (imom /= 1) then
        q1=p(:,5)+p(:,8)
        q2=q1+p(:,6)
        q3=p(:,3)+q2
        q4=p(:,7)+p(:,4)
       end if
       if (ikin == 60) then
       sqsu4=ecm-sqsl3
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=ecm-sqs4
       call mapbkk(imom,x(3),q3,mh,gamh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(3)
       call mapbkk(imom,x(2),q2,mb0,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(5),m(8),x(5:6),p(:,5),p(:,8),dl1)
       call kinff(imom,sqs2,sqs1,m(6),x(7:8),q1,p(:,6),dl2)
       call kinff(imom,sqs3,m(3),sqs2,x(9:10),p(:,3),q2,dl3)
       call kinff(imom,sqs4,m(7),m(4),x(11:12),p(:,7),p(:,4),dl4)
       call kinff(imom,ecm,sqs3,sqs4,x(13:14),q3,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,6))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,4))
       end if
      else if (ikin <= nt67) then
       sqsl1=m(7)+m(4)
       sqsl2=m(5)+m(8)
       sqsl3=m(3)+sqsl2
       sqsl4=sqsl3+m(6)
       if (imom /= 1) then
        q1=p(:,7)+p(:,4)
        q2=p(:,5)+p(:,8)
        q3=p(:,3)+q2
        q4=q3+p(:,6)
       end if
       if (ikin == 61) then
       sqsu1=ecm-sqsl4
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(6)
       call mapbkk(imom,x(3),q3,mb0,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(3)
       call mapbkk(imom,x(2),q2,mz,gamz,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 62) then
       sqsu1=ecm-sqsl4
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(6)
       call mapbkk(imom,x(3),q3,mb0,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(3)
       call mapbkk(imom,x(2),q2,mz,gamz,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(7),m(4),x(5:6),p(:,7),p(:,4),dl1)
       call kinff(imom,sqs2,m(5),m(8),x(7:8),p(:,5),p(:,8),dl2)
       call kinff(imom,sqs3,m(3),sqs2,x(9:10),p(:,3),q2,dl3)
       call kinff(imom,sqs4,sqs3,m(6),x(11:12),q3,p(:,6),dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,4))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt69) then
       sqsl1=m(5)+m(8)
       sqsl2=m(3)+sqsl1
       sqsl3=sqsl2+m(6)
       sqsl4=m(7)+m(4)
       if (imom /= 1) then
        q1=p(:,5)+p(:,8)
        q2=p(:,3)+q1
        q3=q2+p(:,6)
        q4=p(:,7)+p(:,4)
       end if
       if (ikin == 63) then
       sqsu4=ecm-sqsl3
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=ecm-sqs4
       call mapbkk(imom,x(3),q3,mh,gamh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapbkk(imom,x(2),q2,mb0,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(3)
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(5),m(8),x(5:6),p(:,5),p(:,8),dl1)
       call kinff(imom,sqs2,m(3),sqs1,x(7:8),p(:,3),q1,dl2)
       call kinff(imom,sqs3,sqs2,m(6),x(9:10),q2,p(:,6),dl3)
       call kinff(imom,sqs4,m(7),m(4),x(11:12),p(:,7),p(:,4),dl4)
       call kinff(imom,ecm,sqs3,sqs4,x(13:14),q3,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,6))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,4))
       end if
      else if (ikin <= nt70) then
       sqsl1=m(5)+m(8)
       sqsl2=m(3)+sqsl1
       sqsl3=m(7)+m(4)
       sqsl4=sqsl3+m(6)
       if (imom /= 1) then
        q1=p(:,5)+p(:,8)
        q2=p(:,3)+q1
        q3=p(:,7)+p(:,4)
        q4=q3+p(:,6)
       end if
       if (ikin == 64) then
       sqsu4=ecm-sqsl2
       call mapbkk(imom,x(4),q4,mb0,zero,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(6)
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=ecm-sqs4
       call mapbkk(imom,x(2),q2,mb0,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(3)
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 65) then
       sqsu4=ecm-sqsl2
       call mapbkk(imom,x(4),q4,mb0,zero,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(6)
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=ecm-sqs4
       call mapbkk(imom,x(2),q2,mb0,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(3)
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(5),m(8),x(5:6),p(:,5),p(:,8),dl1)
       call kinff(imom,sqs2,m(3),sqs1,x(7:8),p(:,3),q1,dl2)
       call kinff(imom,sqs3,m(7),m(4),x(9:10),p(:,7),p(:,4),dl3)
       call kinff(imom,sqs4,sqs3,m(6),x(11:12),q3,p(:,6),dl4)
       call kinff(imom,ecm,sqs2,sqs4,x(13:14),q2,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,4))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt71) then
       sqsl1=m(7)+m(8)
       sqsl2=m(5)+m(4)
       sqsl3=m(3)+sqsl2
       sqsl4=sqsl3+m(6)
       if (imom /= 1) then
        q1=p(:,7)+p(:,8)
        q2=p(:,5)+p(:,4)
        q3=p(:,3)+q2
        q4=q3+p(:,6)
       end if
       if (ikin == 66) then
       sqsu1=ecm-sqsl4
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mw,gamw,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(6)
       call mapbkk(imom,x(3),q3,mt,gamt,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(3)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(7),m(8),x(5:6),p(:,7),p(:,8),dl1)
       call kinff(imom,sqs2,m(5),m(4),x(7:8),p(:,5),p(:,4),dl2)
       call kinff(imom,sqs3,m(3),sqs2,x(9:10),p(:,3),q2,dl3)
       call kinff(imom,sqs4,sqs3,m(6),x(11:12),q3,p(:,6),dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,4))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,4))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt75) then
       sqsl1=m(7)+m(8)
       sqsl2=sqsl1+m(6)
       sqsl3=m(5)+m(4)
       sqsl4=m(3)+sqsl3
       if (imom /= 1) then
        q1=p(:,7)+p(:,8)
        q2=q1+p(:,6)
        q3=p(:,5)+p(:,4)
        q4=p(:,3)+q3
       end if
       if (ikin == 67) then
       sqsu2=ecm-sqsl4
       call mapbkk(imom,x(2),q2,mt,gamt,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mt,gamt,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(3)
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       call kinff(imom,sqs1,m(7),m(8),x(5:6),p(:,7),p(:,8),dl1)
       call kinff(imom,sqs2,sqs1,m(6),x(7:8),q1,p(:,6),dl2)
       call kinff(imom,sqs3,m(5),m(4),x(9:10),p(:,5),p(:,4),dl3)
       call kinff(imom,sqs4,m(3),sqs3,x(11:12),p(:,3),q3,dl4)
       call kinff(imom,ecm,sqs2,sqs4,x(13:14),q2,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,4))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,4))
       end if
      else if (ikin <= nt77) then
       sqsl1=m(3)+m(6)
       sqsl2=m(7)+m(8)
       sqsl3=sqsl2+m(4)
       sqsl4=m(5)+sqsl3
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,7)+p(:,8)
        q3=q2+p(:,4)
        q4=p(:,5)+q3
       end if
       if (ikin == 68) then
       sqsu1=ecm-sqsl4
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,zero,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(7),m(8),x(7:8),p(:,7),p(:,8),dl2)
       call kinff(imom,sqs3,sqs2,m(4),x(9:10),q2,p(:,4),dl3)
       call kinff(imom,sqs4,m(5),sqs3,x(11:12),p(:,5),q3,dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,4))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,4))
       end if
      end if
 
      end
