      SUBROUTINE vegasn(FXN,xmc,AVGI,SD,CHI2A)
C
C   SUBROUTINE PERFORMS N-DIMENSIONAL MONTE CARLO INTEG'N
C      - BY G.P. LEPAGE   SEPT 1976/(REV)APR 1978
C
      use drivekk
      use bveg1
      use bveg2
      use kinparams

      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION D(50,nvmax),DI(50,nvmax),XIN(50),R(50),DX(nvmax),
     &          DT(nvmax),X(nvmax),KG(nvmax),IA(nvmax)
      REAL*8 QRAN(nvmax)
      real(4) :: qr_sp(nvmax)
c      COMMON/BVEG1/XL(nvmax),XU(nvmax),ACC,NDIM,NCALL,ITMX,NPRN
c      COMMON/BVEG2/XI(50,nvmax),SI,SI2,SWGT,SCHI,NDO,IT
      DATA NDMX/50/,ALPH/1.5D0/,MDS/1/
      real(kind(1.d0)) :: xmc(0:nkin),xmc0(0:nkin),xm0(0:nkin),
     &                    xi_mc(nkin)
      real :: rand(1)
C

      if (iwadapt == 0 .or. iscan0 == 0) then
       xmc0=xmc
       do j=1,nkin
        aw(j)=xmc0(j)-xmc0(j-1)
       end do
      end if

      xi_mc=0.d0

      NDO=1
      do J=1,NDIM
       XI(1,J)=ONE
      end do
C
c      ENTRY vegasn1(FXN,AVGI,SD,CHI2A)
C         - INITIALIZES CUMMULATIVE VARIABLES, BUT NOT GRID
      IT=0
      SI=0.
      SI2=SI
      SWGT=SI
      SCHI=SI
C
c      ENTRY vegasn2(FXN,AVGI,SD,CHI2A)
C         - NO INITIALIZATION
      ND=NDMX
      NG=1
      IF(MDS.EQ.0) GO TO 2
      NG=(NCALL/2.)**(1./NDIM)
      MDS=1
      IF((2*NG-NDMX).LT.0) GO TO 2
      MDS=-1
      NPG=NG/NDMX+1
      ND=NG/NPG
      NG=NPG*ND
2     K=NG**NDIM
      NPG=NCALL/K
      IF(NPG.LT.2) NPG=2
      CALLS=NPG*K
      DXG=ONE/NG
      DV2G=(CALLS*DXG**NDIM)**2/NPG/NPG/(NPG-ONE)
      XND=ND
      NDM=ND-1
      DXG=DXG*XND
      XJAC=ONE/CALLS
      do J=1,NDIM
       DX(J)=XU(J)-XL(J)
       XJAC=XJAC*DX(J)
      end do
C
C   REBIN PRESERVING BIN DENSITY
C
      IF(ND.EQ.NDO) GO TO 8
      RC=NDO/XND
      do J=1,NDIM
       K=0
       XN=0.
       DR=XN
       I=K
4      K=K+1
       DR=DR+ONE
       XO=XN
       XN=XI(K,J)
5      IF(RC.GT.DR) GO TO 4
       I=I+1
       DR=DR-RC
       XIN(I)=XN-(XN-XO)*DR
       IF(I.LT.NDM) GO TO 5
       do I=1,NDM
        XI(I,J)=XIN(I)
       end do
       XI(ND,J)=ONE
      end do
      NDO=ND
C
8     IF(NPRN.NE.0) WRITE(6,200) NDIM,CALLS,IT,ITMX,ACC,MDS,ND
     1                           ,(XL(J),XU(J),J=1,NDIM)
C
c      ENTRY vegasn3(FXN,AVGI,SD,CHI2A)

C         - MAIN INTEGRATION LOOP
      do
       IT=IT+1
       TI=0.
       TSI=TI
       do J=1,NDIM
        KG(J)=1
        do I=1,ND
         D(I,J)=TI
         DI(I,J)=TI
        end do
       end do
C
11     FB=0.
       F2B=FB
       K=0
12     K=K+1
c      call random_number(QRAN)
c      call ranlux(qr_sp,NDIM)
c      QRAN=qr_sp
       CALL ARAN9(QRAN,NDIM)
       WGT=XJAC
       do J=1,NDIM
        XN=(KG(J)-QRAN(J))*DXG+ONE
        IA(J)=XN
        IF(IA(J).GT.1) GO TO 13
        XO=XI(IA(J),J)
        RC=(XN-IA(J))*XO
        GO TO 14
13      XO=XI(IA(J),J)-XI(IA(J)-1,J)
        RC=XI(IA(J)-1,J)+(XN-IA(J))*XO
14      X(J)=XL(J)+RC*DX(J)
C       WRITE(6,*) J,XO,XND
        WGT=WGT*XO*XND
       end do
C
c Choose the kinematics:
       if (iscan == 0) then
        call random_seed
        call random_number(rand)
        do j=1,nkin
         if (dble(rand(1)) < xmc(j)) then
          ikin=j
          exit
         end if
        end do
       end if

       F=WGT
c       F=F*FXN(X,WGT)
       F=F*FXN(X(1:NDIM),NDIM)

c       write(6,*)'F:',ikin,ndim,F

       ntest=ntest+1
       xi_mc(ikin)=xi_mc(ikin)+F
       F2=F*F
       FB=FB+F
       F2B=F2B+F2

       do J=1,NDIM
        DI(IA(J),J)=DI(IA(J),J)+F
        IF(MDS.GE.0) D(IA(J),J)=D(IA(J),J)+F2
       end do
       IF(K.LT.NPG) GO TO 12
C
       F2B=DSQRT(F2B*NPG)
       F2B=(F2B-FB)*(F2B+FB)
       TI=TI+FB
c       WRITE(6,*) 'TI=',TI,FB
       TSI=TSI+F2B
       IF(MDS.GE.0) GO TO 18
       do J=1,NDIM
        D(IA(J),J)=D(IA(J),J)+F2B
       end do
18     K=NDIM
19     KG(K)=MOD(KG(K),NG)+1
       IF(KG(K).NE.1) GO TO 11
       K=K-1
       IF(K.GT.0) GO TO 19
C
C   FINAL RESULTS FOR THIS ITERATION
C
       TSI=TSI*DV2G
       TI2=TI*TI
       WGT=TI2/TSI
       SI=SI+TI*WGT
       SI2=SI2+TI2
       SWGT=SWGT+WGT
       SCHI=SCHI+TI2*WGT
       AVGI=SI/SWGT
       SD=SWGT*IT/SI2
       CHI2A=SD*(SCHI/SWGT-AVGI*AVGI)/(IT-.999)
       SD=DSQRT(DABS(ONE/SD))
C
       xi_mc=xi_mc/TI

       IF(NPRN.EQ.0) GO TO 21
       TSI=DSQRT(TSI)
       WRITE(6,201) IT,TI,TSI,AVGI,SD,CHI2A

c       if (ecm == ecmit) then ! 7 Jan. 2025
        bcsacc(it)=AVGI
        bsdacc(it)=SD**2
        bcall(it)=ntest
c       end if    ! 7 Jan. 2025

       IF(NPRN.GE.0) GO TO 21
       do J=1,NDIM
        WRITE(6,202) J,(XI(I,J),DI(I,J),D(I,J),I=1,ND)
       end do
C
C   REFINE GRID
C
21     do J=1,NDIM
        XO=D(1,J)
        XN=D(2,J)
        D(1,J)=(XO+XN)/2.
        DT(J)=D(1,J)
        do I=2,NDM
         D(I,J)=XO+XN
         XO=XN
         XN=D(I+1,J)
         D(I,J)=(D(I,J)+XN)/3.
         DT(J)=DT(J)+D(I,J)
        end do
        D(ND,J)=(XN+XO)/2.
        DT(J)=DT(J)+D(ND,J)
       end do
C
       do J=1,NDIM
        RC=0.
        do I=1,ND
         R(I)=0.
         IF(D(I,J).LE.0.) GO TO 24
         XO=DT(J)/D(I,J)
         R(I)=((XO-ONE)/XO/DLOG(XO))**ALPH
24       RC=RC+R(I)
        end do
        RC=RC/XND
        K=0
        XN=0.
        DR=XN
        I=K
25      K=K+1
        DR=DR+R(K)
        XO=XN
        XN=XI(K,J)
26      IF(RC.GT.DR) GO TO 25
        I=I+1
        DR=DR-RC
        XIN(I)=XN-(XN-XO)*DR/R(K)
        IF(I.LT.NDM) GO TO 26
        do I=1,NDM
         XI(I,J)=XIN(I)
        end do
        XI(ND,J)=ONE
       end do
C
c       IF(IT.LT.ITMX.AND.ACC*DABS(AVGI).LT.SD) GO TO 9
       IF(IT >= ITMX .or. ACC*DABS(AVGI) > SD) exit
c Recalculate kinematics channel weights for the next iteration:
c       if (po > 0) xm0=xmc
       xm0=xmc
       xmc=0.d0
       do j=1,nkin
        xmc(j)=xmc(j-1)+xi_mc(j)
       end do
       if (po > 0) then
        xmc=po*xm0+(1.d0-po)*xmc
       end if
       if (iwadapt == 1) then
        write(6,'(a,i5,a)') '# Kinematics channels in iteration ',IT+1,
     &                      ' will be selected with new weights:'
        aw=xi_mc
        write(6,'(a,i5,a)') '# Individual contributions of kinematics '
     &    //'channels in iteration ',IT,' are:'
        do j=1,nkin
         if (xi_mc(j) > 0.d0) then
          write(6,'(a,i10,2e14.6)') '#',j,xi_mc(j),xmc(j)
         end if
        end do
       else
        write(6,'(a,i5,a)') '# Kinematics channels in iteration ',IT+1,
     &                      ' will be selected with old weights.'
        do j=1,nkin
         if (aw(j) > 0.d0) then
          write(6,'(a,i10,2e14.6)') '#',j,aw(j),xmc0(j)
         end if
        end do
        write(6,'(a,i5,a)') '# Individual contributions of kinematics '
     &    //'channels in iteration ',IT,' are:'
        do j=1,nkin
         if (xi_mc(j) > 0.d0) then
          write(6,'(a,i10,2e14.6)') '#',j,xi_mc(j),xmc(j)
         end if
        end do
        xmc=xmc0
       end if
       xi_mc=0.d0
      end do
200   FORMAT('0INPUT PARAMETERS FOR vegasn:  NDIM=',I3,'  NCALL=',F8.0
     1    /28X,'  IT=',I5,'  ITMX=',I5/28X,'  ACC=',G10.3
     2    /28X,'  MDS=',I3,'   ND=',I4/28X,'  (XL,XU)=',
     3    (T40,'( ',G13.6,' , ',G13.6,' )'))
201   FORMAT(///' INTEGRATION BY vegasn' / '0ITERATION NO.',I3,
     1    ':   INTEGRAL =',G15.8/21X,'STD DEV  =',G11.4 /
     2    ' ACCUMULATED RESULTS:   INTEGRAL =',G15.8 /
     3    24X,'STD DEV  =',G11.4 / 24X,'CHI**2 PER IT''N =',G11.4)
202   FORMAT('0DATA FOR AXIS',I2 / ' ',6X,'X',7X,'  DELT I  ',
     1    2X,' CONV''CE  ',11X,'X',7X,'  DELT I  ',2X,' CONV''CE  '
     2   ,11X,'X',7X,'  DELT I  ',2X,' CONV''CE  ' /
     2    (' ',3G12.4,5X,3G12.4,5X,3G12.4))
      RETURN
      END
      SUBROUTINE SAVE(NDIM)
      use bveg2
      IMPLICIT REAL*8(A-H,O-Z)
c      COMMON/BVEG2/XI(50,nvmax),SI,SI2,SWGT,SCHI,NDO,IT
C
C   STORES vegasn DATA (UNIT 7) FOR LATER RE-INITIALIZATION
C
      WRITE(7,200) NDO,IT,SI,SI2,SWGT,SCHI,
     1             ((XI(I,J),I=1,NDO),J=1,NDIM)
      RETURN
      ENTRY RESTR(NDIM)
C
C   ENTERS INITIALIZATION DATA FOR vegasn
C
      READ(7,200) NDO,IT,SI,SI2,SWGT,SCHI,
     1            ((XI(I,J),I=1,NDO),J=1,NDIM)
200   FORMAT(2I8,4Z16/(5Z16))
      RETURN
      END
 
      SUBROUTINE ARAN9(QRAN,NDIM)
      use nvegas
      REAL*8 QRAN(nvmax)
      do I=1,NDIM
       CALL R2455(QRAN(I))
      end do
      RETURN
      END
  
      SUBROUTINE R2455(RAN)
C
C SUBTRACTIVE MITCHELL-MOORE GENERATOR
C RONALD KLEISS - OCTOBER 2, 1987
C
C THE ALGORITHM IS N(I)=[ N(I-24) - N(I-55) ]MOD M,
C IMPLEMENTED IN A CIRUCULAR ARRAY WITH IDENTIFCATION
C OF NR(I+55) AND NR(I), SUCH THAT EFFECTIVELY:
C        N(1)   <---   N(32) - N(1)
C        N(2)   <---   N(33) - N(2)  ....
C   .... N(24)  <---   N(55) - N(24)
C        N(25)  <---   N(1)  - N(25) ....
C   .... N(54)  <---   N(30) - N(54)
C        N(55)  <---   N(31) - N(55)
C
C IN THIS VERSION  M =2**30  AND  RM=1/M=2.0**(-30.0)
C
C THE ARRAY N HAS BEEN INITIALIZED BY PUTTING N(I)=I
C AND SUBSEQUENTLY RUNNING THE ALGORITHM 100,000 TIMES.
C
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION N(55)
      DATA N/
     . 980629335, 889272121, 422278310,1042669295, 531256381,
     . 335028099,  47160432, 788808135, 660624592, 793263632,
     . 998900570, 470796980, 327436767, 287473989, 119515078,
     . 575143087, 922274831,  21914605, 923291707, 753782759,
     . 254480986, 816423843, 931542684, 993691006, 343157264,
     . 272972469, 733687879, 468941742, 444207473, 896089285,
     . 629371118, 892845902, 163581912, 861580190,  85601059,
     . 899226806, 438711780, 921057966, 794646776, 417139730,
     . 343610085, 737162282,1024718389,  65196680, 954338580,
     . 642649958, 240238978, 722544540, 281483031,1024570269,
     . 602730138, 915220349, 651571385, 405259519, 145115737/
      DATA M/1073741824/
      DATA RM/0.9313225746154785D-09/
      DATA K/55/,L/31/
      IF(K.EQ.55) THEN
         K=1
      ELSE
         K=K+1
      ENDIF
      IF(L.EQ.55) THEN
         L=1
      ELSE
         L=L+1
      ENDIF
      J=N(L)-N(K)
      IF(J.LT.0) J=J+M
      N(K)=J
      RAN=J*RM
      END
